var ParticleLayer = cc.Layer.extend({
    ctor: function () {
        this._super();

        var dir = 'res/z_test/';
        var size = cc.winSize;
        var particle = zNewParticleCreate(dir, 'star1', this);
        particle.setPosition(0, size.height / 2);
        particle.runAction(cc.sequence(
            zGetBezierTo(1, particle.getPosition(), cc.p(size.width - 50, size.height - 50)),
            cc.callFunc(() => {
                particle.stopSystem();
            }),
            cc.delayTime(2),
            cc.callFunc(() => {
                particle.removeFromParent(true);
            })
        ));
    }
});

var ParticleScene = cc.Scene.extend({
    ctor: function () {
        this._super();

        var layer = new ParticleLayer();
        this.addChild(layer);
    }
});