var Global_DP_Button = {
    dir: 'res/button/'
};

//
//

var zBackButton = cc.Node.extend({
    _onTouchBegan: null,
    _onTouchMoved: null,
    _onTouchEnded: null,
    _onTouchCancel: null,
    ctor: function () {
        this._super();
    },
    setButtonImage: function (dir, name) {
        this.image = zNewSpriteCreate(dir, name, this);
        this.image.setPosition(this.image.width / 2, this.image.height / 2);
        this.setContentSize(this.image.getContentSize());
        this.setAnchorPoint(0.5, 0.5);

        // zShowContentSize(this.image, this.image.getContentSize());
        // zShowContentSize(this, this.getContentSize());
    },
    getButtonImage: function () {
        return this.image;
    },
    setImageGlobalZOrder: function (zOrder) {
        this.image.setGlobalZOrder(zOrder);
    },
    addListener: function () {
        var listener = zNewEventListenerCreate(
            this._onTouchBegan ? this._onTouchBegan : null,
            this._onTouchMoved ? this._onTouchMoved : null,
            this._onTouchEnded ? this._onTouchEnded : null,
            this._onTouchCancel ? this._onTouchCancel : null);
        cc.eventManager.addListener(listener, this);
        return listener;
    },
    setOnTouchBegin: function (onTouchBegin) {
        this._onTouchBegan = onTouchBegin;
    },
    setOnTouchMoved: function (onTouchMoved) {
        this._onTouchMoved = onTouchMoved;
    },
    setOnTouchEnded: function (onTouchEnded) {
        this._onTouchEnded = onTouchEnded;
    },
    setOnTouchCancel: function (onTouchCancel) {
        this._onTouchCancel = onTouchCancel;
    },
});

function zAddButtonBegin(parent, dir, name, callBack) {
    var backButton = new zBackButton();
    backButton.setButtonImage(dir, name);
    backButton.setOnTouchBegin(callBack);
    backButton.addListener();
    parent.addChild(backButton);
    return backButton;
}

function zAddButtonEnded(parent, dir, name, callBack, swallowTouches) {
    var backButton = new zBackButton();
    backButton.setButtonImage(dir, name);
    backButton.setOnTouchEnded(callBack);
    var listener = backButton.addListener();
    listener.setSwallowTouches(swallowTouches ? true : false);
    parent.addChild(backButton);
    return backButton;
}

function zAddBackButtonBegin(parent) {
    var backBtn = zAddButtonBegin(parent, Global_DP_Button.dir, 'back', function (touch, target) {
        zPauseTargetEvent(target, true);
        cc.director.popScene();
    });
    var backBtnImage = backBtn.getButtonImage();
    var pos = parent.convertToNodeSpace(cc.p(0, cc.winSize.height));
    backBtn.setPosition(cc.pAdd(pos, cc.p(backBtnImage.width / 2 + 20, -(backBtnImage.height / 2 + 20))));
    // backBtn.setImageGlobalZOrder(100);
    backBtn.setLocalZOrder(1000);
    return backBtn;
}
