function ddPlayEffect(method, url, loop) {
    var audioid;
    if (cc.sys.os === cc.sys.OS_ANDROID) {
        audioid = jsb.AudioEngine.play2d(url, loop);
    } else {
        if ("music" == method) {
            audioid = cc.audioEngine.playMusic(url, loop);  // 这里不会有返回值
        } else {
            audioid = cc.audioEngine.playEffect(url, loop);
        }
    }
    return audioid;
}

function ddStopEffect(method, audio) {
    if (cc.sys.os == cc.sys.OS_ANDROID) {
        if (jsb.AudioEngine.INVALID_AUDIO_ID !== audio) {
            jsb.AudioEngine.stop(audio);
        }
    } else {
        if (method == "music") {
            cc.audioEngine.stopMusic();        // 这里不需要指定id
        } else if (method == "effect") {
            cc.audioEngine.stopEffect(audio);
        }
    }
}

function ddStopAllEffect() {
    if (cc.sys.os === cc.sys.OS_ANDROID) {
        jsb.AudioEngine.stopAll();
    } else {
        cc.audioEngine.stopAllEffects();
    }
}

var ddSound = {
    dir: 'res/mp3/',
    playMusic: function (name) {
        // this.musicId = ddPlayEffect(, true);
        cc.audioEngine.playMusic(this.dir + name + suffixMP3, true);  // 这里不会有返回值
    },
    stopMusic: function () {
        cc.audioEngine.stopMusic();
    },
    playEffect: function (name, loop) {
        // zLog('res/mp3/' + name + suffixMP3);
        return ddPlayEffect('effect', this.dir + name + suffixMP3, loop ? loop : false);
    },
    stopEffect: function (effectId) {
        ddStopEffect('effect', effectId);
    },
    stopAll: function () {
        ddStopAllEffect();
    }
};