//
// 小手
//

var zTip = cc.Node.extend({
    ctor: function () {
        this._super();
    },
    stopTipAction: function () {
        // zLog('stop tip');
        this.unscheduleAllCallbacks();
        this.setVisible(false);
        this.getChildren().forEach((item) => {
            item.stopAllActions();
            item.setPosition(0, 0);
        });
    }
});

var zTipHand = zTip.extend({
    ctor: function () {
        this._super();
        this.hand = zNewSpriteCreate('res/tip/', 'hand', this);
    },
    tipAction: function () {
        // zLog('tip ...');
        this.setVisible(true);
        this.hand.stopAllActions();
        this.hand.runAction(cc.sequence(
            cc.show(),
            cc.spawn(cc.scaleTo(0.3, 1, 0.8), cc.rotateTo(0.3, -15)).easing(cc.easeOut(2)),
            cc.spawn(cc.scaleTo(0.3, 1, 1), cc.rotateTo(0.3, 0)).easing(cc.easeIn(2)),
            cc.spawn(cc.scaleTo(0.3, 1, 0.8), cc.rotateTo(0.3, -15)).easing(cc.easeOut(2)),
            cc.spawn(cc.scaleTo(0.3, 1, 1), cc.rotateTo(0.3, 0)).easing(cc.easeIn(2)),
            cc.hide()
        ))
    },
    autoTipAction: function (pos) {
        // zLog('auto tip');
        this.setPosition(pos);
        this.schedule(this.tipAction, 4, 655350, 1);
    }
});

function zAddTipHand(parent) {
    var tipHand = new zTipHand();
    parent.addChild(tipHand);
    tipHand.setVisible(false);
    tipHand.setLocalZOrder(100);
    tipHand.setPosition(parent.convertToNodeSpace(cc.p(cc.winSize.width / 2, cc.winSize.height / 2)));
    return tipHand;
}

//
// 箭头
//

var zTipArrow = zTip.extend({
    ctor: function () {
        this._super();
        this.arrow = zNewSpriteCreate('res/tip/', 'arrow', this);
    },
    tipAction: function (pos) {
        this.setVisible(true);
        this.setPosition(pos);
        this.arrow.runAction(cc.sequence(

        ))
    }
});

var zTipArrowCurve = zTip.extend({
    ctor: function () {
        this._super();
        // zLog('path : ', 'res/tip/' + 'arrow_curve' + '.png');
        this.arrow_curve = zNewSpriteCreate('res/tip/', 'arrow_curve', this);
        this.arrow_curve.setAnchorPoint(0, 0.5);
    },
    tipAction: function () {
        this.setVisible(true);
        this.arrow_curve.stopAllActions();
        this.arrow_curve.setRotation(0);
        this.arrow_curve.runAction(cc.sequence(
            cc.show(),
            cc.rotateTo(0.5, 20),
            cc.hide()
        ));
    },
    autoTipAction: function (pos) {
        this.setPosition(pos);
        this.schedule(this.tipAction, 2, 655350, 2);
    }
});

function zAddTipArrowCurve(parent) {
    var tipArrowCurve = new zTipArrowCurve();
    parent.addChild(tipArrowCurve);
    tipArrowCurve.setVisible(false);
    tipArrowCurve.setLocalZOrder(100);
    return tipArrowCurve;
}
