var Global_DP_DiningRoom_MakeIceCream = {
    dir: Global_DP_DiningRoom.dir + 'make_ice_cream/',
    layer: null,
    select_list: null,
    btn_ok: null,
    ice_cream: null,
    step: null,
    tray: null,
    types: [0, 0, 0],
    tip_hand: null
};

function init_Global_DP_DiningRoom_MakeIceCream() {
    Global_DP_DiningRoom_MakeIceCream.step = null;
    Global_DP_DiningRoom_MakeIceCream.types = [0, 0, 0];
}

var DP_DiningRoomMakeIceCream_IceCream = cc.Node.extend({
    ctor: function () {
        this._super();
        Global_DP_DiningRoom_MakeIceCream.ice_cream = this;

        this.base = new cc.Sprite();
        this.head = new cc.Sprite();
        this.stick = new cc.Sprite();
        this.addChild(this.base);
        this.base.addChild(this.head, 1);
        this.base.addChild(this.stick);
        this.setAnchorPoint(0.5, 0.5);
        // zAddTouchLogPosEvent(this.head);
        // zAddTouchLogPosEvent(this.stick);
    },
    setBaseImage: function (dir, name) {
        zSetSpriteTexture(dir, name, this.base);
        this.setContentSize(this.base.getContentSize());
        this.base.setPosition(this.width / 2, this.height / 2);
        this.setPosition(0, 750 / 2);
        this.base.setScale(0.4);
        this.base.runAction(cc.scaleTo(0.3, 1).easing(cc.easeIn(2)));
    },
    setHeadImage: function (dir, name) {
        zSetSpriteTexture(dir, name, this.head);
        this.head.setPosition(179.34, 341.82);
        // this.head.setScale(0.4);
        // this.head.runAction(cc.scaleTo(0.3, 1).easing(cc.easeIn(2)));
    },
    setStickImage: function (dir, name) {
        zSetSpriteTexture(dir, name, this.stick);
        this.stick.setPosition(301.50, 451.39);
    },
    addEvent: function () {
        var listener = zNewEventListenerCreate(function (touch, target) {
            var tip_hand = Global_DP_DiningRoom_MakeIceCream.tip_hand;
            tip_hand.stopTipAction();
        }, function (touch, target) {
            var delta = touch.getDelta();
            target.x += delta.x;
            target.y += delta.y;
        }, function (touch, target) {
            var tray = Global_DP_DiningRoom_MakeIceCream.tray;
            var endPos = cc.pAdd(tray.baseImage.getPosition(), cc.p(tray.baseImage.width / 4, 0));
            zPauseTargetEvent(target, true);
            ddSound.playEffect('game_all_fly');
            target.runAction(cc.sequence(
                // cc.spawn(cc.scaleTo(0.5, 0.5), cc.moveTo(0.5, endPos)).easing(cc.easeOut(2)),
                cc.spawn(cc.scaleTo(0.5, 0.4), zGetBezierTo(0.5, target.getPosition(), endPos)).easing(cc.easeOut(2)),
                cc.callFunc(function () {
                    zChangeParent(target, tray.baseImage);
                    target.setPosition(tray.baseImage.width * 3 / 4, tray.baseImage.height / 2);
                }),
                cc.delayTime(0.5),
                cc.callFunc(() => {
                    tray.out();
                })
            ));
            var layer = Global_DP_DiningRoom_MakeIceCream.layer;
            layer.scheduleOnce(function () {
                DP_DiningRoomMake();
                layer.removeFromParent(true);
            }, 1.5);
        }, null);
        zSetNodeEvent(listener, this);
    }
});

var DP_DiningRoom_MakeIceCreamLayer = cc.Layer.extend({
    ctor: function () {
        this._super();
        Global_DP_DiningRoom_MakeIceCream.layer = this;

        this.addSelectList();
        this.addIceCream();
        this.addButtonOk();
        this.addTray();
        this.addTipHand();
    },
    onExit: function () {
        this._super();
        // init_Global_DP_DiningRoom_MakeIceCream();
        ddSound.stopAll();
        ddSound.playEffect('select_choose_ice_cream_base');
    },
    addSelectList: function () {
        var dir_ice_cream = Global_DP_DiningRoom_MakeIceCream.dir;
        var name_head = ['ice_cream_head_matcha', 'popcorn_taste_mango', 'ice_cream_head_strawberry'];
        var name_stick = ['chocolate', 'strawberry', 'yam'];
        var listener = zNewEventListenerCreate(function (touch, target) {
            // zLog('item idx : ', target.idx);
            // zLog('item name : ', target.getName());
            target.setLocalZOrder(1);
            select_list.pauseOtherItemEvent(target.idx);
            select_list.stopTip();
            ddSound.stopAll();
            if (target.getName().indexOf('head') >= 0) {
                ddSound.playEffect('select_list_' + name_head[target.idx]);
            } else if (target.getName().indexOf('stick') >= 0) {
                // zLog('stick name : ', 'select_list_ice_cream_stick_' + name_stick[target.idx]);
                ddSound.playEffect('select_list_ice_cream_stick_' + name_stick[target.idx]);
                // select_list_ice_cream_stick_chocolate.mp3
                // select_list_ice_cream_stick_chocolate
            }
        }, function (touch, target) {
            var delta = touch.getDelta();
            target.x += delta.x;
            target.y += delta.y;
        }, function (touch, target) {
            // zLog('length : ', select_list.items.length);
            // select_list.setItemBackPos(target.idx);
            var ice_cream = Global_DP_DiningRoom_MakeIceCream.ice_cream;
            var btn_ok = Global_DP_DiningRoom_MakeIceCream.btn_ok;
            var world_pos = cc.p(cc.winSize.width / 2, 750 / 2);
            var argus = {a: dir_ice_cream, b: target.getName()};
            if (target.getName().indexOf('base') >= 0) {
                // ice_cream.setBaseImage(dir_ice_cream, target.getName());
                // ice_cream.setPosition(0, 750 / 2);
                select_list.moveItemBezierTo(target.idx, world_pos, ice_cream.setBaseImage, ice_cream, argus, true);
                Global_DP_DiningRoom_MakeIceCream.types[0] = target.idx;
                Global_DP_DiningRoom_MakeIceCream.step = 'base';
            } else if (target.getName().indexOf('head') >= 0) {
                // ice_cream.setHeadImage(dir_ice_cream, target.getName());
                select_list.moveItemBezierTo(target.idx, cc.pAdd(world_pos, cc.p(0, 200)), ice_cream.setHeadImage, ice_cream, argus, true);
                Global_DP_DiningRoom_MakeIceCream.types[1] = target.idx;
                Global_DP_DiningRoom_MakeIceCream.step = 'head';
            } else if (target.getName().indexOf('stick') >= 0) {
                // ice_cream.setStickImage(dir_ice_cream, target.getName());
                select_list.moveItemBezierTo(target.idx, cc.pAdd(world_pos, cc.p(100, 270)), ice_cream.setStickImage, ice_cream, argus, true);
                Global_DP_DiningRoom_MakeIceCream.types[2] = target.idx;
                Global_DP_DiningRoom_MakeIceCream.step = 'stick';
            }
            btn_ok.into();
        }, null);
        var select_list = zAddSelectList(this,
            {name: 'side_column', zOrder: 10},
            {from: cc.p(cc.winSize.width / 2 + 200, 451.40), to: cc.p(cc.winSize.width / 2 - 120, 451.40), time: 0.5},
            {name: 'side_column_box'},
            {dir: dir_ice_cream, name: ['base_0', 'base_1', 'base_2']},
            listener
        );
        select_list.into();
        // select_list.hide();
        // select_list.pauseEvent();

        Global_DP_DiningRoom_MakeIceCream.select_list = select_list;
    },
    addButtonOk: function () {
        var self = this;
        var dir_ice_cream = Global_DP_DiningRoom_MakeIceCream.dir;
        var btn_ok = zAddDiningRoomButtonOK(self);
        btn_ok.setEventCallBack(function () {
            var select_list = Global_DP_DiningRoom_MakeIceCream.select_list;
            select_list.out();
            btn_ok.out();
            self.scheduleOnce(function () {
                var step = Global_DP_DiningRoom_MakeIceCream.step;
                ddSound.stopAll();
                if (step == 'base') {
                    select_list.setItem(dir_ice_cream, 'head_0', 0);
                    select_list.setItem(dir_ice_cream, 'head_1', 1);
                    select_list.setItem(dir_ice_cream, 'head_2', 2);
                    select_list.into();
                    ddSound.playEffect('select_choose_ice_cream');
                } else if (step == 'head') {
                    select_list.setItem(dir_ice_cream, 'stick_0', 0);
                    select_list.setItem(dir_ice_cream, 'stick_1', 1);
                    select_list.setItem(dir_ice_cream, 'stick_2', 2);
                    select_list.into();
                    ddSound.playEffect('select_choose_decorate');
                } else {
                    var tray = Global_DP_DiningRoom_MakeIceCream.tray;
                    var ice_cream = Global_DP_DiningRoom_MakeIceCream.ice_cream;
                    tray.into();
                    ice_cream.scheduleOnce(function () {
                        ice_cream.addEvent();
                        zAddParticleDone(self);
                        ddSound.stopAll();
                        ddSound.playEffect('game_dinning_room_put_ice_cream_on_tray');
                        var tip_hand = Global_DP_DiningRoom_MakeIceCream.tip_hand;
                        tip_hand.autoTipAction(ice_cream.getPosition());
                    }, 0.5);
                }
            }, 1);
        }, this);
        Global_DP_DiningRoom_MakeIceCream.btn_ok = btn_ok;
    },
    addIceCream: function () {
        var ice_cream = new DP_DiningRoomMakeIceCream_IceCream();
        this.addChild(ice_cream, 5);
        Global_DP_DiningRoom_MakeIceCream.ice_cream = ice_cream;
    },
    addTray: function () {
        Global_DP_DiningRoom_MakeIceCream.tray = zAddDiningRoomTray(this);
    },
    addTipHand: function () {
        var tip_hand = zAddTipHand(this);
        Global_DP_DiningRoom_MakeIceCream.tip_hand = tip_hand;
    }
});